Package org.apache.tomcat.dbcp.dbcp2

## Class DelegatingCallableStatement

- java.lang.Object
- - org.apache.tomcat.dbcp.dbcp2.AbandonedTrace
  - - org.apache.tomcat.dbcp.dbcp2.DelegatingStatement
    - - org.apache.tomcat.dbcp.dbcp2.DelegatingPreparedStatement
      - - org.apache.tomcat.dbcp.dbcp2.DelegatingCallableStatement

All Implemented Interfaces:
  `java.lang.AutoCloseable`, `java.sql.CallableStatement`, `java.sql.PreparedStatement`, `java.sql.Statement`, `java.sql.Wrapper`, `TrackedUse`

Direct Known Subclasses:
  `PoolableCallableStatement`

    public class DelegatingCallableStatement
    extends DelegatingPreparedStatement
    implements java.sql.CallableStatement

A base delegating implementation of `CallableStatement`.

All of the methods from the `CallableStatement` interface simply call the corresponding method on the "delegate" provided in my constructor.

Extends AbandonedTrace to implement Statement tracking and logging of code which created the Statement. Tracking the Statement ensures that the Connection which created it can close any open Statement's on Connection close.

Since:
  2.0

### Field Summary

### Fields inherited from interface java.sql.Statement

`CLOSE_ALL_RESULTS, CLOSE_CURRENT_RESULT, EXECUTE_FAILED, KEEP_CURRENT_RESULT, NO_GENERATED_KEYS, RETURN_GENERATED_KEYS, SUCCESS_NO_INFO`

### Constructor Summary

Constructors
`DelegatingCallableStatement​(DelegatingConnection<?> connection, java.sql.CallableStatement statement)` Creates a wrapper for the Statement which traces this Statement to the Connection which created it and the code which created it.

### Method Summary

All Methods Instance Methods Concrete Methods Deprecated Methods
`java.sql.Array` `getArray​(int parameterIndex)`
`java.sql.Array` `getArray​(java.lang.String parameterName)`
`java.math.BigDecimal` `getBigDecimal​(int parameterIndex)`
`java.math.BigDecimal` `getBigDecimal​(int parameterIndex, int scale)` Deprecated. Use `getBigDecimal(int)` or `getBigDecimal(String)`
`java.math.BigDecimal` `getBigDecimal​(java.lang.String parameterName)`
`java.sql.Blob` `getBlob​(int parameterIndex)`
`java.sql.Blob` `getBlob​(java.lang.String parameterName)`
`boolean` `getBoolean​(int parameterIndex)`
`boolean` `getBoolean​(java.lang.String parameterName)`
`byte` `getByte​(int parameterIndex)`
`byte` `getByte​(java.lang.String parameterName)`
`byte[]` `getBytes​(int parameterIndex)`
`byte[]` `getBytes​(java.lang.String parameterName)`
`java.io.Reader` `getCharacterStream​(int parameterIndex)`
`java.io.Reader` `getCharacterStream​(java.lang.String parameterName)`
`java.sql.Clob` `getClob​(int parameterIndex)`
`java.sql.Clob` `getClob​(java.lang.String parameterName)`
`java.sql.Date` `getDate​(int parameterIndex)`
`java.sql.Date` `getDate​(int parameterIndex, java.util.Calendar cal)`
`java.sql.Date` `getDate​(java.lang.String parameterName)`
`java.sql.Date` `getDate​(java.lang.String parameterName, java.util.Calendar cal)`
`double` `getDouble​(int parameterIndex)`
`double` `getDouble​(java.lang.String parameterName)`
`float` `getFloat​(int parameterIndex)`
`float` `getFloat​(java.lang.String parameterName)`
`int` `getInt​(int parameterIndex)`
`int` `getInt​(java.lang.String parameterName)`
`long` `getLong​(int parameterIndex)`
`long` `getLong​(java.lang.String parameterName)`
`java.io.Reader` `getNCharacterStream​(int parameterIndex)`
`java.io.Reader` `getNCharacterStream​(java.lang.String parameterName)`
`java.sql.NClob` `getNClob​(int parameterIndex)`
`java.sql.NClob` `getNClob​(java.lang.String parameterName)`
`java.lang.String` `getNString​(int parameterIndex)`
`java.lang.String` `getNString​(java.lang.String parameterName)`
`java.lang.Object` `getObject​(int parameterIndex)`
`<T> T` `getObject​(int parameterIndex, java.lang.Class<T> type)`
`java.lang.Object` `getObject​(int i, java.util.Map<java.lang.String,​java.lang.Class<?>> map)`
`java.lang.Object` `getObject​(java.lang.String parameterName)`
`<T> T` `getObject​(java.lang.String parameterName, java.lang.Class<T> type)`
`java.lang.Object` `getObject​(java.lang.String parameterName, java.util.Map<java.lang.String,​java.lang.Class<?>> map)`
`java.sql.Ref` `getRef​(int parameterIndex)`
`java.sql.Ref` `getRef​(java.lang.String parameterName)`
`java.sql.RowId` `getRowId​(int parameterIndex)`
`java.sql.RowId` `getRowId​(java.lang.String parameterName)`
`short` `getShort​(int parameterIndex)`
`short` `getShort​(java.lang.String parameterName)`
`java.sql.SQLXML` `getSQLXML​(int parameterIndex)`
`java.sql.SQLXML` `getSQLXML​(java.lang.String parameterName)`
`java.lang.String` `getString​(int parameterIndex)`
`java.lang.String` `getString​(java.lang.String parameterName)`
`java.sql.Time` `getTime​(int parameterIndex)`
`java.sql.Time` `getTime​(int parameterIndex, java.util.Calendar cal)`
`java.sql.Time` `getTime​(java.lang.String parameterName)`
`java.sql.Time` `getTime​(java.lang.String parameterName, java.util.Calendar cal)`
`java.sql.Timestamp` `getTimestamp​(int parameterIndex)`
`java.sql.Timestamp` `getTimestamp​(int parameterIndex, java.util.Calendar cal)`
`java.sql.Timestamp` `getTimestamp​(java.lang.String parameterName)`
`java.sql.Timestamp` `getTimestamp​(java.lang.String parameterName, java.util.Calendar cal)`
`java.net.URL` `getURL​(int parameterIndex)`
`java.net.URL` `getURL​(java.lang.String parameterName)`
`void` `registerOutParameter​(int parameterIndex, int sqlType)`
`void` `registerOutParameter​(int parameterIndex, int sqlType, int scale)`
`void` `registerOutParameter​(int paramIndex, int sqlType, java.lang.String typeName)`
`void` `registerOutParameter​(int parameterIndex, java.sql.SQLType sqlType)`
`void` `registerOutParameter​(int parameterIndex, java.sql.SQLType sqlType, int scale)`
`void` `registerOutParameter​(int parameterIndex, java.sql.SQLType sqlType, java.lang.String typeName)`
`void` `registerOutParameter​(java.lang.String parameterName, int sqlType)`
`void` `registerOutParameter​(java.lang.String parameterName, int sqlType, int scale)`
`void` `registerOutParameter​(java.lang.String parameterName, int sqlType, java.lang.String typeName)`
`void` `registerOutParameter​(java.lang.String parameterName, java.sql.SQLType sqlType)`
`void` `registerOutParameter​(java.lang.String parameterName, java.sql.SQLType sqlType, int scale)`
`void` `registerOutParameter​(java.lang.String parameterName, java.sql.SQLType sqlType, java.lang.String typeName)`
`void` `setAsciiStream​(java.lang.String parameterName, java.io.InputStream inputStream)`
`void` `setAsciiStream​(java.lang.String parameterName, java.io.InputStream x, int length)`
`void` `setAsciiStream​(java.lang.String parameterName, java.io.InputStream inputStream, long length)`
`void` `setBigDecimal​(java.lang.String parameterName, java.math.BigDecimal x)`
`void` `setBinaryStream​(java.lang.String parameterName, java.io.InputStream inputStream)`
`void` `setBinaryStream​(java.lang.String parameterName, java.io.InputStream x, int length)`
`void` `setBinaryStream​(java.lang.String parameterName, java.io.InputStream inputStream, long length)`
`void` `setBlob​(java.lang.String parameterName, java.io.InputStream inputStream)`
`void` `setBlob​(java.lang.String parameterName, java.io.InputStream inputStream, long length)`
`void` `setBlob​(java.lang.String parameterName, java.sql.Blob blob)`
`void` `setBoolean​(java.lang.String parameterName, boolean x)`
`void` `setByte​(java.lang.String parameterName, byte x)`
`void` `setBytes​(java.lang.String parameterName, byte[] x)`
`void` `setCharacterStream​(java.lang.String parameterName, java.io.Reader reader)`
`void` `setCharacterStream​(java.lang.String parameterName, java.io.Reader reader, int length)`
`void` `setCharacterStream​(java.lang.String parameterName, java.io.Reader reader, long length)`
`void` `setClob​(java.lang.String parameterName, java.io.Reader reader)`
`void` `setClob​(java.lang.String parameterName, java.io.Reader reader, long length)`
`void` `setClob​(java.lang.String parameterName, java.sql.Clob clob)`
`void` `setDate​(java.lang.String parameterName, java.sql.Date x)`
`void` `setDate​(java.lang.String parameterName, java.sql.Date x, java.util.Calendar cal)`
`void` `setDouble​(java.lang.String parameterName, double x)`
`void` `setFloat​(java.lang.String parameterName, float x)`
`void` `setInt​(java.lang.String parameterName, int x)`
`void` `setLong​(java.lang.String parameterName, long x)`
`void` `setNCharacterStream​(java.lang.String parameterName, java.io.Reader reader)`
`void` `setNCharacterStream​(java.lang.String parameterName, java.io.Reader reader, long length)`
`void` `setNClob​(java.lang.String parameterName, java.io.Reader reader)`
`void` `setNClob​(java.lang.String parameterName, java.io.Reader reader, long length)`
`void` `setNClob​(java.lang.String parameterName, java.sql.NClob value)`
`void` `setNString​(java.lang.String parameterName, java.lang.String value)`
`void` `setNull​(java.lang.String parameterName, int sqlType)`
`void` `setNull​(java.lang.String parameterName, int sqlType, java.lang.String typeName)`
`void` `setObject​(java.lang.String parameterName, java.lang.Object x)`
`void` `setObject​(java.lang.String parameterName, java.lang.Object x, int targetSqlType)`
`void` `setObject​(java.lang.String parameterName, java.lang.Object x, int targetSqlType, int scale)`
`void` `setObject​(java.lang.String parameterName, java.lang.Object x, java.sql.SQLType targetSqlType)`
`void` `setObject​(java.lang.String parameterName, java.lang.Object x, java.sql.SQLType targetSqlType, int scaleOrLength)`
`void` `setRowId​(java.lang.String parameterName, java.sql.RowId value)`
`void` `setShort​(java.lang.String parameterName, short x)`
`void` `setSQLXML​(java.lang.String parameterName, java.sql.SQLXML value)`
`void` `setString​(java.lang.String parameterName, java.lang.String x)`
`void` `setTime​(java.lang.String parameterName, java.sql.Time x)`
`void` `setTime​(java.lang.String parameterName, java.sql.Time x, java.util.Calendar cal)`
`void` `setTimestamp​(java.lang.String parameterName, java.sql.Timestamp x)`
`void` `setTimestamp​(java.lang.String parameterName, java.sql.Timestamp x, java.util.Calendar cal)`
`void` `setURL​(java.lang.String parameterName, java.net.URL val)`
`boolean` `wasNull()`

### Methods inherited from class org.apache.tomcat.dbcp.dbcp2.DelegatingPreparedStatement

`addBatch, clearParameters, execute, executeLargeUpdate, executeQuery, executeUpdate, getMetaData, getParameterMetaData, prepareToReturn, setArray, setAsciiStream, setAsciiStream, setAsciiStream, setBigDecimal, setBinaryStream, setBinaryStream, setBinaryStream, setBlob, setBlob, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setCharacterStream, setCharacterStream, setClob, setClob, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNCharacterStream, setNCharacterStream, setNClob, setNClob, setNClob, setNString, setNull, setNull, setObject, setObject, setObject, setObject, setObject, setRef, setRowId, setShort, setSQLXML, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL, toString`

### Methods inherited from class org.apache.tomcat.dbcp.dbcp2.DelegatingStatement

`activate, addBatch, cancel, checkOpen, clearBatch, clearWarnings, close, closeOnCompletion, execute, execute, execute, execute, executeBatch, executeLargeBatch, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, finalize, getConnection, getConnectionInternal, getDelegate, getFetchDirection, getFetchSize, getGeneratedKeys, getInnermostDelegate, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, handleException, isClosed, isClosedInternal, isCloseOnCompletion, isPoolable, isWrapperFor, passivate, setClosedInternal, setCursorName, setDelegate, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout, unwrap`

### Methods inherited from class org.apache.tomcat.dbcp.dbcp2.AbandonedTrace

`addTrace, clearTrace, close, getLastUsed, getLastUsedInstant, getTrace, removeThisTrace, removeTrace, setLastUsed, setLastUsed, setLastUsed`

### Methods inherited from class java.lang.Object

`clone, equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface java.sql.PreparedStatement

`addBatch, clearParameters, execute, executeLargeUpdate, executeQuery, executeUpdate, getMetaData, getParameterMetaData, setArray, setAsciiStream, setAsciiStream, setAsciiStream, setBigDecimal, setBinaryStream, setBinaryStream, setBinaryStream, setBlob, setBlob, setBlob, setBoolean, setByte, setBytes, setCharacterStream, setCharacterStream, setCharacterStream, setClob, setClob, setClob, setDate, setDate, setDouble, setFloat, setInt, setLong, setNCharacterStream, setNCharacterStream, setNClob, setNClob, setNClob, setNString, setNull, setNull, setObject, setObject, setObject, setObject, setObject, setRef, setRowId, setShort, setSQLXML, setString, setTime, setTime, setTimestamp, setTimestamp, setUnicodeStream, setURL`

### Methods inherited from interface java.sql.Statement

`addBatch, cancel, clearBatch, clearWarnings, close, closeOnCompletion, enquoteIdentifier, enquoteLiteral, enquoteNCharLiteral, execute, execute, execute, execute, executeBatch, executeLargeBatch, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeLargeUpdate, executeQuery, executeUpdate, executeUpdate, executeUpdate, executeUpdate, getConnection, getFetchDirection, getFetchSize, getGeneratedKeys, getLargeMaxRows, getLargeUpdateCount, getMaxFieldSize, getMaxRows, getMoreResults, getMoreResults, getQueryTimeout, getResultSet, getResultSetConcurrency, getResultSetHoldability, getResultSetType, getUpdateCount, getWarnings, isClosed, isCloseOnCompletion, isPoolable, isSimpleIdentifier, setCursorName, setEscapeProcessing, setFetchDirection, setFetchSize, setLargeMaxRows, setMaxFieldSize, setMaxRows, setPoolable, setQueryTimeout`

### Methods inherited from interface java.sql.Wrapper

`isWrapperFor, unwrap`

### Constructor Detail

#### DelegatingCallableStatement

    public DelegatingCallableStatement​(DelegatingConnection<?> connection,
                                       java.sql.CallableStatement statement)

Creates a wrapper for the Statement which traces this Statement to the Connection which created it and the code which created it.

Parameters:
  `connection` - the `DelegatingConnection` that created this statement
  `statement` - the `CallableStatement` to delegate all calls to

### Method Detail

#### getArray

    public java.sql.Array getArray​(int parameterIndex)
                            throws java.sql.SQLException

Specified by:
  `getArray` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getArray

    public java.sql.Array getArray​(java.lang.String parameterName)
                            throws java.sql.SQLException

Specified by:
  `getArray` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBigDecimal

    public java.math.BigDecimal getBigDecimal​(int parameterIndex)
                                       throws java.sql.SQLException

Specified by:
  `getBigDecimal` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBigDecimal

    @Deprecated
    public java.math.BigDecimal getBigDecimal​(int parameterIndex,
                                              int scale)
                                       throws java.sql.SQLException

Deprecated.
Use `getBigDecimal(int)` or `getBigDecimal(String)`

Specified by:
  `getBigDecimal` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBigDecimal

    public java.math.BigDecimal getBigDecimal​(java.lang.String parameterName)
                                       throws java.sql.SQLException

Specified by:
  `getBigDecimal` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBlob

    public java.sql.Blob getBlob​(int parameterIndex)
                          throws java.sql.SQLException

Specified by:
  `getBlob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBlob

    public java.sql.Blob getBlob​(java.lang.String parameterName)
                          throws java.sql.SQLException

Specified by:
  `getBlob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBoolean

    public boolean getBoolean​(int parameterIndex)
                       throws java.sql.SQLException

Specified by:
  `getBoolean` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBoolean

    public boolean getBoolean​(java.lang.String parameterName)
                       throws java.sql.SQLException

Specified by:
  `getBoolean` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getByte

    public byte getByte​(int parameterIndex)
                 throws java.sql.SQLException

Specified by:
  `getByte` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getByte

    public byte getByte​(java.lang.String parameterName)
                 throws java.sql.SQLException

Specified by:
  `getByte` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBytes

    public byte[] getBytes​(int parameterIndex)
                    throws java.sql.SQLException

Specified by:
  `getBytes` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getBytes

    public byte[] getBytes​(java.lang.String parameterName)
                    throws java.sql.SQLException

Specified by:
  `getBytes` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getCharacterStream

    public java.io.Reader getCharacterStream​(int parameterIndex)
                                      throws java.sql.SQLException

Specified by:
  `getCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getCharacterStream

    public java.io.Reader getCharacterStream​(java.lang.String parameterName)
                                      throws java.sql.SQLException

Specified by:
  `getCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getClob

    public java.sql.Clob getClob​(int parameterIndex)
                          throws java.sql.SQLException

Specified by:
  `getClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getClob

    public java.sql.Clob getClob​(java.lang.String parameterName)
                          throws java.sql.SQLException

Specified by:
  `getClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getDate

    public java.sql.Date getDate​(int parameterIndex)
                          throws java.sql.SQLException

Specified by:
  `getDate` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getDate

    public java.sql.Date getDate​(int parameterIndex,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Specified by:
  `getDate` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getDate

    public java.sql.Date getDate​(java.lang.String parameterName)
                          throws java.sql.SQLException

Specified by:
  `getDate` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getDate

    public java.sql.Date getDate​(java.lang.String parameterName,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Specified by:
  `getDate` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getDouble

    public double getDouble​(int parameterIndex)
                     throws java.sql.SQLException

Specified by:
  `getDouble` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getDouble

    public double getDouble​(java.lang.String parameterName)
                     throws java.sql.SQLException

Specified by:
  `getDouble` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getFloat

    public float getFloat​(int parameterIndex)
                   throws java.sql.SQLException

Specified by:
  `getFloat` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getFloat

    public float getFloat​(java.lang.String parameterName)
                   throws java.sql.SQLException

Specified by:
  `getFloat` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getInt

    public int getInt​(int parameterIndex)
               throws java.sql.SQLException

Specified by:
  `getInt` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getInt

    public int getInt​(java.lang.String parameterName)
               throws java.sql.SQLException

Specified by:
  `getInt` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getLong

    public long getLong​(int parameterIndex)
                 throws java.sql.SQLException

Specified by:
  `getLong` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getLong

    public long getLong​(java.lang.String parameterName)
                 throws java.sql.SQLException

Specified by:
  `getLong` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getNCharacterStream

    public java.io.Reader getNCharacterStream​(int parameterIndex)
                                       throws java.sql.SQLException

Specified by:
  `getNCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getNCharacterStream

    public java.io.Reader getNCharacterStream​(java.lang.String parameterName)
                                       throws java.sql.SQLException

Specified by:
  `getNCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getNClob

    public java.sql.NClob getNClob​(int parameterIndex)
                            throws java.sql.SQLException

Specified by:
  `getNClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getNClob

    public java.sql.NClob getNClob​(java.lang.String parameterName)
                            throws java.sql.SQLException

Specified by:
  `getNClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getNString

    public java.lang.String getNString​(int parameterIndex)
                                throws java.sql.SQLException

Specified by:
  `getNString` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getNString

    public java.lang.String getNString​(java.lang.String parameterName)
                                throws java.sql.SQLException

Specified by:
  `getNString` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getObject

    public java.lang.Object getObject​(int parameterIndex)
                               throws java.sql.SQLException

Specified by:
  `getObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getObject

    public <T> T getObject​(int parameterIndex,
                           java.lang.Class<T> type)
                    throws java.sql.SQLException

Specified by:
  `getObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getObject

    public java.lang.Object getObject​(int i,
                                      java.util.Map<java.lang.String,​java.lang.Class<?>> map)
                               throws java.sql.SQLException

Specified by:
  `getObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getObject

    public java.lang.Object getObject​(java.lang.String parameterName)
                               throws java.sql.SQLException

Specified by:
  `getObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getObject

    public <T> T getObject​(java.lang.String parameterName,
                           java.lang.Class<T> type)
                    throws java.sql.SQLException

Specified by:
  `getObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getObject

    public java.lang.Object getObject​(java.lang.String parameterName,
                                      java.util.Map<java.lang.String,​java.lang.Class<?>> map)
                               throws java.sql.SQLException

Specified by:
  `getObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getRef

    public java.sql.Ref getRef​(int parameterIndex)
                        throws java.sql.SQLException

Specified by:
  `getRef` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getRef

    public java.sql.Ref getRef​(java.lang.String parameterName)
                        throws java.sql.SQLException

Specified by:
  `getRef` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getRowId

    public java.sql.RowId getRowId​(int parameterIndex)
                            throws java.sql.SQLException

Specified by:
  `getRowId` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getRowId

    public java.sql.RowId getRowId​(java.lang.String parameterName)
                            throws java.sql.SQLException

Specified by:
  `getRowId` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getShort

    public short getShort​(int parameterIndex)
                   throws java.sql.SQLException

Specified by:
  `getShort` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getShort

    public short getShort​(java.lang.String parameterName)
                   throws java.sql.SQLException

Specified by:
  `getShort` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getSQLXML

    public java.sql.SQLXML getSQLXML​(int parameterIndex)
                              throws java.sql.SQLException

Specified by:
  `getSQLXML` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getSQLXML

    public java.sql.SQLXML getSQLXML​(java.lang.String parameterName)
                              throws java.sql.SQLException

Specified by:
  `getSQLXML` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getString

    public java.lang.String getString​(int parameterIndex)
                               throws java.sql.SQLException

Specified by:
  `getString` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getString

    public java.lang.String getString​(java.lang.String parameterName)
                               throws java.sql.SQLException

Specified by:
  `getString` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTime

    public java.sql.Time getTime​(int parameterIndex)
                          throws java.sql.SQLException

Specified by:
  `getTime` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTime

    public java.sql.Time getTime​(int parameterIndex,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Specified by:
  `getTime` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTime

    public java.sql.Time getTime​(java.lang.String parameterName)
                          throws java.sql.SQLException

Specified by:
  `getTime` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTime

    public java.sql.Time getTime​(java.lang.String parameterName,
                                 java.util.Calendar cal)
                          throws java.sql.SQLException

Specified by:
  `getTime` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTimestamp

    public java.sql.Timestamp getTimestamp​(int parameterIndex)
                                    throws java.sql.SQLException

Specified by:
  `getTimestamp` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTimestamp

    public java.sql.Timestamp getTimestamp​(int parameterIndex,
                                           java.util.Calendar cal)
                                    throws java.sql.SQLException

Specified by:
  `getTimestamp` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTimestamp

    public java.sql.Timestamp getTimestamp​(java.lang.String parameterName)
                                    throws java.sql.SQLException

Specified by:
  `getTimestamp` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getTimestamp

    public java.sql.Timestamp getTimestamp​(java.lang.String parameterName,
                                           java.util.Calendar cal)
                                    throws java.sql.SQLException

Specified by:
  `getTimestamp` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getURL

    public java.net.URL getURL​(int parameterIndex)
                        throws java.sql.SQLException

Specified by:
  `getURL` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### getURL

    public java.net.URL getURL​(java.lang.String parameterName)
                        throws java.sql.SQLException

Specified by:
  `getURL` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### registerOutParameter

    public void registerOutParameter​(int parameterIndex,
                                     int sqlType)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### registerOutParameter

    public void registerOutParameter​(int parameterIndex,
                                     int sqlType,
                                     int scale)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### registerOutParameter

    public void registerOutParameter​(int paramIndex,
                                     int sqlType,
                                     java.lang.String typeName)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### registerOutParameter

    public void registerOutParameter​(int parameterIndex,
                                     java.sql.SQLType sqlType)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### registerOutParameter

    public void registerOutParameter​(int parameterIndex,
                                     java.sql.SQLType sqlType,
                                     int scale)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### registerOutParameter

    public void registerOutParameter​(int parameterIndex,
                                     java.sql.SQLType sqlType,
                                     java.lang.String typeName)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### registerOutParameter

    public void registerOutParameter​(java.lang.String parameterName,
                                     int sqlType)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### registerOutParameter

    public void registerOutParameter​(java.lang.String parameterName,
                                     int sqlType,
                                     int scale)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### registerOutParameter

    public void registerOutParameter​(java.lang.String parameterName,
                                     int sqlType,
                                     java.lang.String typeName)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### registerOutParameter

    public void registerOutParameter​(java.lang.String parameterName,
                                     java.sql.SQLType sqlType)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### registerOutParameter

    public void registerOutParameter​(java.lang.String parameterName,
                                     java.sql.SQLType sqlType,
                                     int scale)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### registerOutParameter

    public void registerOutParameter​(java.lang.String parameterName,
                                     java.sql.SQLType sqlType,
                                     java.lang.String typeName)
                              throws java.sql.SQLException

Specified by:
  `registerOutParameter` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### setAsciiStream

    public void setAsciiStream​(java.lang.String parameterName,
                               java.io.InputStream inputStream)
                        throws java.sql.SQLException

Specified by:
  `setAsciiStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setAsciiStream

    public void setAsciiStream​(java.lang.String parameterName,
                               java.io.InputStream x,
                               int length)
                        throws java.sql.SQLException

Specified by:
  `setAsciiStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setAsciiStream

    public void setAsciiStream​(java.lang.String parameterName,
                               java.io.InputStream inputStream,
                               long length)
                        throws java.sql.SQLException

Specified by:
  `setAsciiStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBigDecimal

    public void setBigDecimal​(java.lang.String parameterName,
                              java.math.BigDecimal x)
                       throws java.sql.SQLException

Specified by:
  `setBigDecimal` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBinaryStream

    public void setBinaryStream​(java.lang.String parameterName,
                                java.io.InputStream inputStream)
                         throws java.sql.SQLException

Specified by:
  `setBinaryStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBinaryStream

    public void setBinaryStream​(java.lang.String parameterName,
                                java.io.InputStream x,
                                int length)
                         throws java.sql.SQLException

Specified by:
  `setBinaryStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBinaryStream

    public void setBinaryStream​(java.lang.String parameterName,
                                java.io.InputStream inputStream,
                                long length)
                         throws java.sql.SQLException

Specified by:
  `setBinaryStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBlob

    public void setBlob​(java.lang.String parameterName,
                        java.sql.Blob blob)
                 throws java.sql.SQLException

Specified by:
  `setBlob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBlob

    public void setBlob​(java.lang.String parameterName,
                        java.io.InputStream inputStream)
                 throws java.sql.SQLException

Specified by:
  `setBlob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBlob

    public void setBlob​(java.lang.String parameterName,
                        java.io.InputStream inputStream,
                        long length)
                 throws java.sql.SQLException

Specified by:
  `setBlob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBoolean

    public void setBoolean​(java.lang.String parameterName,
                           boolean x)
                    throws java.sql.SQLException

Specified by:
  `setBoolean` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setByte

    public void setByte​(java.lang.String parameterName,
                        byte x)
                 throws java.sql.SQLException

Specified by:
  `setByte` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setBytes

    public void setBytes​(java.lang.String parameterName,
                         byte[] x)
                  throws java.sql.SQLException

Specified by:
  `setBytes` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setCharacterStream

    public void setCharacterStream​(java.lang.String parameterName,
                                   java.io.Reader reader)
                            throws java.sql.SQLException

Specified by:
  `setCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setCharacterStream

    public void setCharacterStream​(java.lang.String parameterName,
                                   java.io.Reader reader,
                                   int length)
                            throws java.sql.SQLException

Specified by:
  `setCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setCharacterStream

    public void setCharacterStream​(java.lang.String parameterName,
                                   java.io.Reader reader,
                                   long length)
                            throws java.sql.SQLException

Specified by:
  `setCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setClob

    public void setClob​(java.lang.String parameterName,
                        java.sql.Clob clob)
                 throws java.sql.SQLException

Specified by:
  `setClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setClob

    public void setClob​(java.lang.String parameterName,
                        java.io.Reader reader)
                 throws java.sql.SQLException

Specified by:
  `setClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setClob

    public void setClob​(java.lang.String parameterName,
                        java.io.Reader reader,
                        long length)
                 throws java.sql.SQLException

Specified by:
  `setClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setDate

    public void setDate​(java.lang.String parameterName,
                        java.sql.Date x)
                 throws java.sql.SQLException

Specified by:
  `setDate` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setDate

    public void setDate​(java.lang.String parameterName,
                        java.sql.Date x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

Specified by:
  `setDate` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setDouble

    public void setDouble​(java.lang.String parameterName,
                          double x)
                   throws java.sql.SQLException

Specified by:
  `setDouble` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setFloat

    public void setFloat​(java.lang.String parameterName,
                         float x)
                  throws java.sql.SQLException

Specified by:
  `setFloat` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setInt

    public void setInt​(java.lang.String parameterName,
                       int x)
                throws java.sql.SQLException

Specified by:
  `setInt` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setLong

    public void setLong​(java.lang.String parameterName,
                        long x)
                 throws java.sql.SQLException

Specified by:
  `setLong` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNCharacterStream

    public void setNCharacterStream​(java.lang.String parameterName,
                                    java.io.Reader reader)
                             throws java.sql.SQLException

Specified by:
  `setNCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNCharacterStream

    public void setNCharacterStream​(java.lang.String parameterName,
                                    java.io.Reader reader,
                                    long length)
                             throws java.sql.SQLException

Specified by:
  `setNCharacterStream` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNClob

    public void setNClob​(java.lang.String parameterName,
                         java.sql.NClob value)
                  throws java.sql.SQLException

Specified by:
  `setNClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNClob

    public void setNClob​(java.lang.String parameterName,
                         java.io.Reader reader)
                  throws java.sql.SQLException

Specified by:
  `setNClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNClob

    public void setNClob​(java.lang.String parameterName,
                         java.io.Reader reader,
                         long length)
                  throws java.sql.SQLException

Specified by:
  `setNClob` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNString

    public void setNString​(java.lang.String parameterName,
                           java.lang.String value)
                    throws java.sql.SQLException

Specified by:
  `setNString` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNull

    public void setNull​(java.lang.String parameterName,
                        int sqlType)
                 throws java.sql.SQLException

Specified by:
  `setNull` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setNull

    public void setNull​(java.lang.String parameterName,
                        int sqlType,
                        java.lang.String typeName)
                 throws java.sql.SQLException

Specified by:
  `setNull` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x)
                   throws java.sql.SQLException

Specified by:
  `setObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x,
                          int targetSqlType)
                   throws java.sql.SQLException

Specified by:
  `setObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x,
                          int targetSqlType,
                          int scale)
                   throws java.sql.SQLException

Specified by:
  `setObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x,
                          java.sql.SQLType targetSqlType)
                   throws java.sql.SQLException

Specified by:
  `setObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### setObject

    public void setObject​(java.lang.String parameterName,
                          java.lang.Object x,
                          java.sql.SQLType targetSqlType,
                          int scaleOrLength)
                   throws java.sql.SQLException

Specified by:
  `setObject` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`
Since:
  2.5.0

#### setRowId

    public void setRowId​(java.lang.String parameterName,
                         java.sql.RowId value)
                  throws java.sql.SQLException

Specified by:
  `setRowId` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setShort

    public void setShort​(java.lang.String parameterName,
                         short x)
                  throws java.sql.SQLException

Specified by:
  `setShort` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setSQLXML

    public void setSQLXML​(java.lang.String parameterName,
                          java.sql.SQLXML value)
                   throws java.sql.SQLException

Specified by:
  `setSQLXML` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setString

    public void setString​(java.lang.String parameterName,
                          java.lang.String x)
                   throws java.sql.SQLException

Specified by:
  `setString` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setTime

    public void setTime​(java.lang.String parameterName,
                        java.sql.Time x)
                 throws java.sql.SQLException

Specified by:
  `setTime` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setTime

    public void setTime​(java.lang.String parameterName,
                        java.sql.Time x,
                        java.util.Calendar cal)
                 throws java.sql.SQLException

Specified by:
  `setTime` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setTimestamp

    public void setTimestamp​(java.lang.String parameterName,
                             java.sql.Timestamp x)
                      throws java.sql.SQLException

Specified by:
  `setTimestamp` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setTimestamp

    public void setTimestamp​(java.lang.String parameterName,
                             java.sql.Timestamp x,
                             java.util.Calendar cal)
                      throws java.sql.SQLException

Specified by:
  `setTimestamp` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### setURL

    public void setURL​(java.lang.String parameterName,
                       java.net.URL val)
                throws java.sql.SQLException

Specified by:
  `setURL` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`

#### wasNull

    public boolean wasNull()
                    throws java.sql.SQLException

Specified by:
  `wasNull` in interface `java.sql.CallableStatement`
Throws:
  `java.sql.SQLException`